# gcd.awk

BEGIN { 
        if (ARGC < 3 )
        {
          print "usage awk -f gcd.awk n1 n2"
          exit
        }
        n1 = ARGV[1]
        n2 = ARGV[2]
        while (n1 != 0 && n2 != 0)
        {
         if (n1 < n2)
           n2 = n2 % n1
         else
           n1 = n1 % n2
        }
        if ( n1 == 0)
             n1 = n2
        print "gcd(", ARGV[1], ",", ARGV[2], ") = ", n1 
}
