# merge2.awk
#
#  Usage:  awk -f merge.awk file1 file2
#
# Input files are assumed to be consisted of number only,
#   one number per line, SORTED, and the program only has to 
#    merge them into one sorted file sent to the standard output
#
BEGIN { 
        first_file = ARGV[1]
        ARGV[1] = NULL # Bypass first file when generating standard input
        first_file_flag = (getline first_file_number < first_file)
      } # BEGIN

# main loop

{
 
  (first_file_flag > 0) && (first_file_number < $1)
    {
     do 
      {
       if (first_file_number < $1) 
             print first_file_number
       else
          break
      } while( (first_file_flag = \
           (getline first_file_number < first_file) ) > 0 )
    } 
  print $1

} # main loop

END {
     if (first_file_flag > 0) # first file not exhausted
      do {
          print first_file_number
         } while( (getline first_file_number < first_file) > 0 )
    } # END
