/* demo_sig_par.c -- traps a signal -  */

#include <stdio.h>
#include <signal.h>

void handler(int signum)
{
  if(signum == SIGINT)
  {
   signal(SIGINT, handler);
   printf("I wont be interrupted!\n");
  } /* if */
  else 
    if(signum == SIGTSTP)
    {
     signal(SIGTSTP, handler);
     printf("I wont be suspended!\n");
    } /* if */

} // handler


int main()
{
  int i, pid;

  signal(SIGINT, handler);
  signal(SIGTSTP, handler);

  for (i=1; i < 50; i++)
   {
     printf("Ha Ha Ha Ha \n");
     sleep(2);
   } /* for */

  return 0;

} /* main */
