/* group1.c - group demo.  */

#include <stdio.h>
#include <signal.h>


void main() /* nice command */
{
  int new_grppid, old_grppid, i;
  
  old_grppid = getpgrp();
  if (setpgrp() == -1)
        perror("setpgrp");
  new_grppid = getpgrp();

  printf("old_grppid = %d, new_grppid = %d\n\n",old_grppid, new_grppid);

  switch(fork())
  {
   case -1:
      perror("fork");
   case 0:
    for (i=1; i < 50; i++)
     {
       printf("Child 1:... \n");
       sleep(2);
     } /* for */
    exit(0); 

  } /* switch */

  switch(fork())
  {
   case -1:
      perror("fork");
   case 0:
    for (i=1; i < 50; i++)
     {
       printf("Child 2:... \n");
       sleep(2);
     } /* for */
    exit(0); 

  } /* switch */


   for (i=0; i < 5; i++)
     {
       printf("Parent Process:... \n");
       sleep(2);
     } /* for */

   kill(0, SIGTERM);


} /* main */
