/* nice.c - Private version of the nice command.  */

#include <stdio.h>

#define USAGE "usage: nice [-num] command\n"

void main(argc, argv) /* nice command */
int argc;
char *argv[];
{
 int incr, cmdarg, niceflag;

  if (argc < 2)
  {
   fprintf(stderr, USAGE);
   exit(1);
  } /* if */

  if (argv[1][0] == '-')
  {
   incr = atoi(&argv[1][1]);
   cmdarg = 2;
  } /* if */
  else
  {
   incr = 10;
   cmdarg = 1;
  } /* else  */

  if (cmdarg >= argc)
  {
   fprintf(stderr, USAGE);
   exit(1);
  } /* if */

  niceflag = nice(incr);
  printf("niceflag = %d\n", niceflag);
  execvp(argv[cmdarg], &argv[cmdarg]);
  perror("execvp");
  

} /* main */
