/* nice2.c - nice command demo.  */

#include <stdio.h>

#define USAGE "usage: nice [-num] command\n"

void main(argc, argv) /* nice command */
int argc;
char *argv[];
{
 int incr, cmdarg, niceflag, i;

  if (argc < 2)
  {
   fprintf(stderr, USAGE);
   exit(1);
  } /* if */

  if (argv[1][0] == '-')
  {
   incr = atoi(&argv[1][1]);
   cmdarg = 2;
  } /* if */
  else
  {
   incr = 10;
   cmdarg = 1;
  } /* else  */

  if (cmdarg >= argc)
  {
   fprintf(stderr, USAGE);
   exit(1);
  } /* if */

  switch(fork())
  {
   case -1:
      perror("fork");
   case 0:
    niceflag = nice(incr);
    printf("niceflag = %d\n", niceflag);
    execvp(argv[cmdarg], &argv[cmdarg]);
    perror("execvp");
  }

  for (i=1; i < 50; i++)
  {
    printf("Ha Ha Ha Ha \n");
    sleep(2);
  }


} /* main */
