#define SIZE 10
#include <fcntl.h>
#include <errno.h>

main(argc,argv)
int argc;
char *argv[];
{
 int fd;            /* file descriptor */
 char buff[SIZE];   /* temporary storage buffer */
 int n;             /* number of characters read */


  if (argc != 2) 
    { 
      printf("Usage: %s filename\n",argv[0]);
      exit(1);
    }
  
  if  ( (fd = open(argv[1], O_RDONLY) ) == -1 ) /* open file, if cant */
   {
    perror(argv[0]);
    exit(1);
   }

  while ( (n = read (fd, buff, SIZE) ) > 0 ) /* read until end */
    write(1, buff, n);

  close(fd);

}
