/* sock_client.c */
 
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
 
  int main()
  {
    
    int32_t sockfd;
    char str[64] = "Hello World!"; 
    char str1[64]; 
    struct sockaddr_in server = {AF_INET, 7000};
    int i;

    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if(sockfd == -1)
    {
      perror("socket");
      exit(1);
    } /* if */
 
    server.sin_addr.s_addr = inet_addr("127.0.0.1");

    if(connect(sockfd,(struct sockaddr*) &server, 
      sizeof(server)) == -1)
    {
      perror("connect");
      exit(1);
    }
 
    // perform read write operations ...
 
    i = 0;
    do {
        send(sockfd, &str[i], 1, 0);
        if ( recv(sockfd, &str1[i], 1, 0) <= 0)
        {
           fprintf(stderr, "\nServer has  died\n");
           exit(1);
        } /* if */ 
        i++;
       }  while (str[i-1] != '\0');

 
    close(sockfd);

    printf("Original message = %s\n", str);
    printf("Returned message = %s\n", str1);
 

    return 0;
  } /* main */

