/* sock_client2.c */
 
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
 
  int main()
  {
    
    int32_t sockfd;
    char str[64] = "Hello World!"; 
    char str1[64]; 
    struct sockaddr_in server = { AF_INET, 7000};
    struct sockaddr_in client = { AF_INET, INADDR_ANY, INADDR_ANY};
    int i;

    sockfd = socket(AF_INET, SOCK_DGRAM, 0);
    if(sockfd == -1)
    {
      perror("socket");
      exit(-1);
    } /* if */
 
 
    server.sin_addr.s_addr = inet_addr("127.0.0.1");


    if( bind(sockfd,(struct sockaddr*) &client, 
      sizeof(client)) == -1)
    {
      perror("bind");
      exit(1);
    }
 
    // perform read write operations ...
 
    i = 0;
    do {
        if (sendto(sockfd, &str[i], 1, 0,(struct sockaddr*) &server, 
                                         sizeof(server))== -1)
        {
           perror("sendto");
           continue;
        } /* if */

        if ( recv(sockfd, &str1[i], 1, 0) <= 0)
        {
           fprintf(stderr, "\nServer has  died\n");
           exit(1);
        } /* if */ 
        i++;
       }  while (str[i-1] != '\0');

 
    close(sockfd);


    printf("Original message = %s\n", str);
    printf("Returned message = %s\n", str1);
 

    return 0;
  }

