/* th_ex5.c */

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

pthread_mutex_t mutex1 = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mutex2 = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  cond1  = PTHREAD_COND_INITIALIZER;
pthread_cond_t  cond2  = PTHREAD_COND_INITIALIZER;

void *producer();
void *consumer();

int  n = 0;
int flag = 0;

int main()
{
   pthread_t thread1, thread2;

   pthread_create( &thread1, NULL, &producer, NULL);
   pthread_create( &thread2, NULL, &consumer, NULL);
   pthread_join( thread1, NULL);
   pthread_join( thread2, NULL);

   exit(0);
}

void *producer()
{
  int i;

   for(i=0;i < 20;i++)
   {
      pthread_mutex_lock( &mutex1 );
      if (flag == 0)
      {
         flag = 2;
         pthread_cond_wait( &cond1, &mutex1 );
      } /* if */
      n++;
      pthread_mutex_unlock( &mutex1 );
      pthread_mutex_lock( &mutex2 );
      if (flag == 3)
      {
        flag = 0;
        pthread_cond_signal(&cond2);
      } /* if */
      flag = 0;
      pthread_mutex_unlock( &mutex2 );

    } /* for */
} /* producer */

void *consumer()
{
 int i;

   for(i=0;i < 20;i++)
   {
      pthread_mutex_lock( &mutex1 );
      printf("n = %d\n", n);
      if (flag == 2)
      {
         flag = 1;
         pthread_cond_signal(&cond1);
      } /* if */
      flag = 1;
      pthread_mutex_unlock( &mutex1 );
      pthread_mutex_lock( &mutex2 );
      if (flag == 1)
      {
        flag = 3;
        pthread_cond_wait( &cond2, &mutex2 );
      } /* if */
      pthread_mutex_unlock( &mutex2 );

    } /* for */

}/* consumer */


