/* trap6.c -- traps a signal - version 3.0  */

#include <stdio.h>
#include <signal.h>

void main()
{
  int pid;

  switch( pid = fork() )
  {
   case -1: /* No new process */
    perror("fork");
    exit(1);

   case 0:  /*child process */
    execl("./trap2","trap2", NULL);
    perror("execl"); /* We should not be here */
    exit(1);
  } /* switch */

  /* parant process only */
  sleep(6);
  kill(pid,SIGINT);
  sleep(6);
  kill(pid,SIGKILL);

} /* main */

