/* twait.c - Use the system command */

#include <stdio.h>

int time_restricted_wait(int secs, int *status)
{
 int id, result;

  if ( (id = fork()) == 0)
  {
   sleep(secs);
   exit(0);
  }
  else /* paraent process */
  {
   result = wait(&status);
   if (id == result)
     return 0;
   else 
    return result;
  }
    
}

void main()
{
  int id, child_id, status;
  
  if ((id = fork()) == 0)
      {
        sleep(8);
        exit(0);
      }
   else
    child_id = time_restricted_wait(4, &status);

  printf("\ngetpid = %d, id = %d\n", getpid(), id);
  printf("\nchild_id = %d, status = %d\n", child_id, status);
    
  child_id = time_restricted_wait(8, &status);

  printf("\nchild_id = %d, status = %d\n", child_id, status);
    
 

}
