/* writef1.c - Read an existing file, send to console  */

#define SIZE 10
#include <fcntl.h>
#include <errno.h>

main(argc,argv)
int argc;
char *argv[];
{
 int fd;            /* file descriptor */
 char buff[SIZE];   /* temporary storage buffer */
 int n;             /* number of characters read */


  if (argc != 2) 
    { 
      printf("Usage: %s filename\n",argv[0]);
      exit(1);
    }
  
  if  ( (fd = open(argv[2], O_CREAT | O_WRONLY, 0640 ) ) == -1 ) 
   /* open file, if cant */
   {
    perror(argv[0]);
    exit(1);
   }

  while ( (n = read (0, buff, SIZE) ) > 0 ) /* read until end */
      write(fd, buff, n);
 
  close(fd);

}
