# addcomma.awk  - put commas in numbers
# input: a number per line
# output: The numbers with commas and two decimal places

  {printf("%-12s %20s\n", $0, addcomma($0))}

function addcomma(x, num)
{
  if (x < 0)
    return "-" addcomma(-x)
  num = sprintf("%.2f", x)  # num is ddddd.dd

     # As long as there are 4 consecutive digits
  while (num ~ /[0-9][0-9][0-9][0-9]/) 
     # find the first 3 digits + ',' or '.'
     # replace the matching string with ',' + itself  
        sub(/[0-9][0-9][0-9][,.]/,",&", num) 
  return num
}
