/* async2.c -  prod2, cons2 */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>


volatile int	*n;		


/*------------------------------------------------------------------------
 *  main  --  producer and consumer processes synchronized with semaphores
 *------------------------------------------------------------------------
 */
int  main()
{
	int	prod2(), cons2();
	int	semid, shmid;
        struct  shmid_ds buff;

        shmid = shmget(IPC_PRIVATE, sizeof(int), 0666);  
        n = (int*)shmat(shmid,0,0);
        *n = 0;


        if ( fork() == 0 )
          /* Child process    */
            cons2();
        else /* Parent process */
         prod2();

        shmdt((char *)n);
        shmctl(shmid, IPC_RMID, &buff);

   return 0;

}

/*------------------------------------------------------------------------
 *  prod2  --  increment n 20 times
 *------------------------------------------------------------------------
 */

int prod2()
{
	int	i;


	for (i=1; i<=20; i++) {
		(*n)++;
	}
}

/*------------------------------------------------------------------------
 *  cons2  --  print n 20 times
 *------------------------------------------------------------------------
 */

int cons2()
{
	int	i;



	for (i=1; i<=20; i++) {
		printf("n is %d\n", *n);
	}
}
