// bank2.c

#include <stdio.h>
#include <pthread.h>

#define NO_OF_CLIENTS 2
#define TRUE 1

typedef struct bank_client
{
  char name[80];
  int amount;

} BANK_CLIENT,  *BANK_CLIENT_PTR;

static BANK_CLIENT bank[NO_OF_CLIENTS]= {{"yossi", 250}, {"shimon", 400}};
pthread_mutex_t mutex1 = PTHREAD_MUTEX_INITIALIZER;



void *tradeForever()
  {
    int sums[] ={50, 100, -75, -50, 125, -100, -50};
    int n = 7;
    int index = 0;
    int amountToTrade;
    int fromAmount;

   while(TRUE)
   {
    amountToTrade = sums[index];
    index = (index + 1)%n;
    
    pthread_mutex_lock( &mutex1 );
    bank[0].amount -= amountToTrade;
    bank[1].amount += amountToTrade;
    pthread_mutex_unlock( &mutex1 );
   } // while

  } // tradeForever

 void *checkTotalAmountForever()
  {
   while(TRUE)
   {
    pthread_mutex_lock( &mutex1 );
 
    printf("Total amount in Bank: %d\n",
          bank[0].amount + bank[1].amount);

    pthread_mutex_unlock( &mutex1 );

   } // while

  } // checkTotalAmountForever
  

  int main()
  {
   pthread_t thread_no1, thread_no2;

   pthread_mutex_init(&mutex1, NULL);
   pthread_create(&thread_no1, NULL, tradeForever, NULL);
   pthread_create(&thread_no2, NULL, checkTotalAmountForever, NULL);

   pthread_join( thread_no1, NULL);
   pthread_join( thread_no2, NULL);

  } // Main

