/* fdate2.c - perform "date > datefile.txt ", using a new process.  */

#include <fcntl.h>
#include "myutils.h"

void main()
{
   int fd, status;
 
   switch(fork())
   {
     case -1:
       syserr("fork");
    
     case 0:  /* Son process */
      if ( (fd = open("datefile.txt", O_WRONLY | O_CREAT,0600)) == -1 )
          syserr("open");

      if (close(1) == -1)
          syserr("close");
 
      if ( dup(fd) != 1 )
          fatal("dup");
  
      execl("/bin/date", "date", NULL);
      syserr("execl");

   } /* switch  */

   wait(&status);
   puts("\n*** Parent process terminating...");

} /* main */
