/*  fifosend.c */

#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

char *fifo = "/tmp/newfifo";

void fatal(char str[])
{
 fprintf(stderr, "%s\n", str);
 exit(0);
} /* fatal */

int main()
{
 int fd, i, nwrite;
 char msgbuf[] = "Hello World!\n";

 if ( (fd = open(fifo, O_WRONLY | O_NONBLOCK)) < 0)
   fatal("fifo open failed");
 
 if ((write(fd, msgbuf, strlen(msgbuf)+1)) < 0)
   fatal("fifo write failed");
 
  return 0;

} /* main */

