/* memdemo2.c - demonstrate virtual mode addressing - UNIX */

#include <stdio.h>

int n = 100;

void main()
{
  int id, *nptr;

  nptr = &n;
  if ( ( id =  fork() ) == 0 )
  {  /* select child process */
     puts("\n**************  child process ***********\n");

     n = 999; 

     printf("PID is %d and ID is %d.\n", getpid(), id);
     printf("n is %d, *nptr is %d and nptr is %p.\n", n, *nptr, nptr);
     puts("\n**************  child process ***********\n");
     
     sleep(6);

     puts("\n**************  child process ***********\n");
     printf("PID is %d and ID is %d.\n", getpid(), id);
     printf("n is %d, *nptr is %d and nptr is %p.\n", n, *nptr, nptr);
     puts("\n**************  child process ***********\n");
   
     exit(0);
  }


     sleep(5);
     puts("\n**************  parent process ***********\n");
     printf("PID is %d and ID is %d.\n", getpid(), id);
     printf("n is %d, *nptr is %d and nptr is %p.\n", n, *nptr, nptr);
     puts("\n**************  parent process ***********\n");

     *nptr = 555; 

     puts("**************  parent process ***********\n");
     printf("PID is %d and ID is %d.\n", getpid(), id);
     printf("n is %d, *nptr is %d and nptr is %p.\n", n, *nptr, nptr);
     puts("\n**************  parent process ***********\n");


}
