/* pipe5.c - implement date | wc.  */

#include <stdio.h>
#include <unistd.h>


void syserr(char str[])
{
  perror(str);
  exit(1);
} /* sys_arr */


int main()
{
  int  pfd[2];
  int status;

  if (pipe(pfd) == -1)
    syserr("pipe");
  switch(fork())
  {
   case -1:
     syserr("fork");
   case 0:
     if (dup2(pfd[1], 1) == -1)
         syserr("dup2");
     if (close(pfd[0])  == -1 || close(pfd[1])  == -1)
        syserr("close");
     execlp("date", "date", NULL);
     syserr("execlp");
  } /* switch */

  switch(fork())
  {
   case -1:
     syserr("fork");
   case 0:
     if (dup2(pfd[0], 0) == -1)
         syserr("dup2");
     if (close(pfd[0])  == -1 || close(pfd[1])  == -1)
        syserr("close");
     execlp("wc", "wc", NULL);
     syserr("execlp2");
  } /* switch */

 if (close(pfd[0])  == -1 || close(pfd[1])  == -1)
     syserr("close");
  
  while (wait(&status) != -1)
      ;

  return 0;

} /* main */
