/* redirect2.c */

#include <stdio.h>
#include <fcntl.h>

void fatal(char str[])
{
  fprintf(stderr, "%s\n", str);
  exit(1);
} // fatal

void sys_err(char str[])
{
 perror(str);
 exit(2);
} // sys_err


int main()
{

 if (fork() == 0) /* Child */
  {
   int fd;


   if( close(1) == -1)
       sys_err("close");

   if ( (fd = open("hello.txt", O_WRONLY | O_CREAT |O_TRUNC, 0644)) == -1)
      sys_err("open");

   if (fd != 1)
      fatal("Unexpected dup result"); 
     
    execl("./hello", "hello", 0);

  } /* if */

 printf("Parent terminating\n");

} /* main */
