/* semaph1.c -  prod2, cons2 */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>


int	n=0;		/* external variables are shared by all processes */

int screate(key)
int key;
{
  int result;
  
  result = semget( (key_t) key, 1, 0666 | IPC_CREAT ); 

  return result;

}



/*------------------------------------------------------------------------
 *  main  --  producer and consumer processes synchronized with semaphores
 *------------------------------------------------------------------------
 */
void  main()
{
	int	prod2(), cons2();
	int	produced, consumed;

	consumed = screate(0);
	produced = screate(1);

/*	resume(create(cons2,INITSTK,INITPRIO,"cons",2,consumed,produced));
	resume(create(prod2,INITSTK,INITPRIO,"prod",2,consumed,produced)); */

        if ( fork() )
          /* Parent process    */
           cons2(consumed,produced);
        else /* Child process */
         prod2(consumed,produced);


}

/*------------------------------------------------------------------------
 *  prod2  --  increment n 20 times, waiting for it to be consumed
 *------------------------------------------------------------------------
 */

void prod2(consumed,produced)
int consumed,produced;
{
	int	i;

	for (i=1; i<=20; i++) {
		waitsem(consumed);
		n++;
		sigsem(produced);
	}
}

/*------------------------------------------------------------------------
 *  cons2  --  print n 20 times, waiting for it to be produced
 *------------------------------------------------------------------------
 */

void cons2(consumed,produced)
int consumed,produced;
{
	int	i;

	for (i=1; i<=20; i++) {
		waitsem(produced);
		printf("n is %d\n",n);
		sigsem(consumed);
	}
}
