/* semaph4.c -  prod2, cons2 */



int screate(sid, key)
int sid[2];
int key;
{
  int result;
  int buf = 1;
  
  result = pipe(sid);
  if (key > 0) 
    write(sid[1],&buf, sizeof(buf));

  return result;

}

int waitsem(sid)
int sid[2];
{
  int buf;

  read(sid[0],&buf, sizeof(buf));
  return buf;

}

int sigsem(sid, n)
int sid[2];
int n;
{
  write(sid[1],&n,sizeof(n));
}



/*------------------------------------------------------------------------
 *  main  --  producer and consumer processes synchronized with semaphores
 *------------------------------------------------------------------------
 */
void  main()
{
	int	prod2(), cons2();
	int	produced[2], consumed[2];

	if ( (screate(consumed,0) == -1) || 
              (screate(produced,1) == -1) )
                syserr("pipe");


        if ( fork() )
          /* Parent process    */
           cons2(consumed,produced);
        else /* Child process */
         prod2(consumed,produced);


}

/*------------------------------------------------------------------------
 *  prod2  --  increment n 20 times, waiting for it to be consumed
 *------------------------------------------------------------------------
 */

int prod2(consumed,produced)
int consumed[2],produced[2];
{
	int	i, n;

	for (i=1; i<=20; i++) {
		n = waitsem(consumed);
		n++;
		sigsem(produced, n);
	}
}

/*------------------------------------------------------------------------
 *  cons2  --  print n 20 times, waiting for it to be produced
 *------------------------------------------------------------------------
 */

int cons2(consumed,produced)
int consumed[2],produced[2];
{
	int	i, n;

	for (i=1; i<=20; i++) {
		n = waitsem(produced);
		printf("n is %d\n",n);
		sigsem(consumed, n);
	}
}
