/* sock_server2.c */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

#define SIZE sizeof(struct sockaddr_in)

int main()
  {
    struct sockaddr_in server = {AF_INET, 7000,INADDR_ANY};
    int32_t sockfd;
    char c;
    struct sockaddr_in client;
    int client_ln = SIZE;
    

    sockfd = socket(AF_INET, SOCK_DGRAM, 0);
    if( sockfd == -1)
    {
      printf("can not create socket");
      exit(-1);
    } /* if */
 
    if( bind(sockfd,(struct sockaddr*) &server, 
               SIZE) == -1)
    {
      perror("bind");
      exit(1);
    } /* if */
 
    for(; ;)
    {
 
     // perform read write operations ...
 
        if( recvfrom(sockfd, &c, 1, 0, 
          (struct sockaddr *)&client, &client_ln) == -1)
        {
         perror("recvfrom");
         continue;
        } /* if */

        c = toupper(c);
  
        if (sendto(sockfd, &c, 1, 0, 
              (struct sockaddr *) &client, 
                                 client_ln) == -1)
        {
         perror("sendto");
         continue;
        } /* if */
    } /* for */
    
    return 0;
  } /* main */

