/* parent2.c - pipe information to cat.  */

#include <stdio.h>
#include "myutils.h"

void main()
{
  int  pfd[2];

  if (pipe(pfd) == -1)
    syserr("pipe");
  switch(fork())
  {
   case -1:
     syserr("fork");
   case 0:
     if (close(0) == -1)
        syserr("close");
     if (dup(pfd[0]) != 0)
         fatal("dup");
     if (close(pfd[0])  == -1 || close(pfd[1])  == -1)
        syserr("close2");
     execlp("sort", "sort", NULL);
     syserr("execlp");
  } /* switch */

  if (close(pfd[0]) == -1)
    syserr("close3");
  if (write(pfd[1], "Hello world\nAaaaa\n", 18) == -1)
    syserr("write");
  if (close(pfd[1]) == -1)
    syserr("close4");

} /* main */
