/* trap7.c -- traps a signal - version 4.0  */

#include <stdio.h>
#include <signal.h>

void main()
{
  int pid;

  pid = getpid();
  switch( fork() )
  {
   case -1: /* No new process */
    perror("fork");
    exit(1);

   case 0:  /* Child process */      
    sleep(6);
    kill(pid,SIGINT);
    sleep(6);
    kill(pid,SIGKILL);
    exit(0);
  } /* switch */

  /* Parant process */
    execl("./trap2","trap2", NULL);
    perror("execl"); /* We should not be here */
    exit(1);

} /* main */


