#include <stdio.h>
#include <signal.h>
#include <sys/types.h>


int create(char path[], char argv0[], char parm[])
{
  int pid;
  
  if ( (pid = fork()) != 0  )
  {
    kill(getpid(), SIGSTOP);
    execl(path, argv0, parm, 0 );
    exit(0);
  } /* child */
  else /* parent */
   return getppid(); 

} /* create */


int resume(int pid)
{
  return (kill(pid, SIGCONT));
} /* resume */ 

void main(void)
{
  int pid;

  
  printf("Before Create\n");

  pid = create("/sbin/ping", "ping", "study.haifa.ac.il");

  sleep(3);

  printf("Before Resume\n");

  resume(pid);

} /* main */
